<!DOCTYPE html>
<html>

<head>
  <meta charset="utf-8" name="viewport" content="width=device-width, initial-scale=1">
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/6.2.1/css/all.min.css">
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
  <!-- Import DataTable Library -->
  <!-- Data Table-->
  <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
  <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
  <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
  <title>User Table</title>
</head>

<body>
  <div class="container bg-light rounded">
    <div class="row p-3">
      <div class="col-sm-12 text-center">
        <h3><span class="border-bottom text-primary"><b>F100 - QUẢN TRỊ NGƯỜI DÙNG</b></span></h3>
      </div>
    </div>
    <div class="row p-3">
      <div class="col-sm-2">
        <label class="col-form-label"><b>Role</b></label>
      </div>
      <div class="col-sm-7">
        <select id="select-role" class="form-control"></select>
      </div>
      <div class="col-sm-3">
        <button id="btn-filter" class="btn btn-primary w-100">Lọc dữ liệu</button>
      </div>
    </div>
    <div class="row p-3">
      <div class="col-sm-12">
        <table id="user-table" class="table table-bordered table-striped table-hover">
          <thead>
            <tr>
              <th>STT</th>
              <th>Username</th>
              <th>Firstname</th>
              <th>Lastname</th>
              <th>Email</th>
              <th>Age</th>
              <th>Role</th>
              <th>Action</th>
            </tr>
          </thead>
          <tbody></tbody>
        </table>
      </div>
    </div>
    <!-- Modal Dice History -->
    <div class="row p-3">
      <div id="modal-dice-history" class="modal fade" tabindex="-1">
        <div class="modal-dialog modal-xl">
          <div class="modal-content">
            <div class="modal-header">
              <h4>DICE HISTORY</h4>
              <a role="button" class="close" data-dismiss="modal">&times;</a>
            </div>
            <div class="modal-body bg-light">
              <div class="row">
                <div class="col-sm-12">
                  <p><b>Thông tin người chơi</b></p>
                </div>
              </div>
              <div class="row form-group">
                <div class="col-sm-1">
                  <label class="col-form-label">Username:</label>
                </div>
                <div class="col-sm-3">
                  <input id="inp-dice-username" class="form-control" placeholder="Username...">
                </div>
                <div class="col-sm-1">
                  <label class="col-form-label">Firstname:</label>
                </div>
                <div class="col-sm-3">
                  <input id="inp-dice-firstname" class="form-control" placeholder="Firstname...">
                </div>
                <div class="col-sm-1">
                  <label class="col-form-label">Lastname:</label>
                </div>
                <div class="col-sm-3">
                  <input id="inp-dice-lastname" class="form-control" placeholder="Lastname...">
                </div>
              </div>
              <div class="row">
                <div class="col-sm-12">
                  <table id="table-dice-history" class="table table-light table-bordered table-striped table-hover">
                    <thead>
                      <tr>
                        <th>Lần chơi</th>
                        <th>Kết quả</th>
                      </tr>
                    </thead>
                    <tbody>
                      
                    </tbody>
                  </table>
                </div>
              </div>
            </div>
            <div class="modal-footer">
              <button class="btn btn-secondary" data-dismiss="modal">Quay lại</button>
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>
</body>

<script>
  /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
  const gBASE_URL = "http://203.171.20.210:8080/devcamp-lucky-dice";
  // Mảng gUserObjects là mảng chứa dữ liệu users
  var gUserObjects = [
        {
          id: 2,
          username: "quannv",
          firstname: "Ngo Van",
          lastname: "Quan",
          age: 18,
          email: "quan@gmail.com",
          roleId: 5
        },
        {
          id: 3,
          username: "longdh",
          firstname: "Do Hoang",
          lastname: "Long",
          age: 19,
          email: "long@gmail.com",
          roleId: 8
        },
        {
          id: 4,
          username: "hiendt",
          firstname: "Do Thi",
          lastname: "Hien",
          age: 29,
          email: "hien@gmail.com",
          roleId: 11
        },
        {
          id: 6,
          username: "lanht",
          firstname: "Ho Thi",
          lastname: "Lan",
          age: 27,
          email: "lan@gmail.com",
          roleId: 13
        }
  ];
  // Mảng gRoleObjects là mảng chứa dữ liệu các roles
  var gRoleObjects = [
        {
          roleId: 5,
          roleName: "Admin" 
        },
        {
          roleId: 8,
          roleName: "Manager" 
        },
        {
          roleId: 11,
          roleName: "Teacher" 
        },
        {
          roleId: 13,
          roleName: "Staff" 
        }
  ];

  var gSTT = 1;
  const gTABLE_ROW = ["id", "username", "firstname", "lastname", "age", "email", "roleId", "action"];
  const gSTT_COL = 0;
  const gUSERNAME_COL = 1;
  const gFIRSTNAME_COL = 2;
  const gLASTNAME_COL = 3;
  const gAGE_COL = 4;
  const gEMAIL_COL = 5;
  const gROLE_COL = 6;
  const gACTION_COL = 7;

  var gTable = $("#user-table").DataTable({
    columns: [
      {data: gTABLE_ROW[gSTT_COL]},
      {data: gTABLE_ROW[gUSERNAME_COL]},
      {data: gTABLE_ROW[gFIRSTNAME_COL]},
      {data: gTABLE_ROW[gLASTNAME_COL]},
      {data: gTABLE_ROW[gAGE_COL]},
      {data: gTABLE_ROW[gEMAIL_COL]},
      {data: gTABLE_ROW[gROLE_COL]},
      {data: gTABLE_ROW[gACTION_COL]},
    ],
    columnDefs: [
      {
        targets: gSTT_COL,
        render: function() {
          return gSTT++;
        }
      },
      {
        targets: gROLE_COL,
        render: getRoleNameByRoleId
      },
      {
        targets: gACTION_COL,
        defaultContent: `
          <i class="fa-solid fa-lg fa-dice dice-history text-success" title="Dice History" role="button"></i>
          <i class="fa-solid fa-lg fa-gift voucher-history text-success ml-2" title="Voucher History" role="button"></i>
        `
      }
    ]
  });

  var gUser = {
    username: "",
    firstname: "",
    lastname: ""
  };
  
  /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
  $(document).ready(function() {
    // gán sự kiện load trang/F5
    onPageLoading();
    // gán sự kiện click button Lọc dữ liệu
    $(document).on("click", "#btn-filter", onBtnFilterClick);
    // gán sự kiện click button Dice History
    $(document).on("click", ".dice-history", onBtnDiceHistoryClick);
  })
  
  /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
  // function xử lý sự kiện load trang/F5
  function onPageLoading() {
    loadRoleDataToSelect();
    getDataAndDisplayTable(gUserObjects);
  }

  // function xử lý sự kiện click button Lọc dữ liệu
  function onBtnFilterClick() {
    // B1: Thu thập dữ liệu
    let vSelectRoleId = $("#select-role").val();
    let vFilterData = getFilterRoleData(vSelectRoleId);
    // B2: Kiểm tra dữ liệu
    // B3: Xử lý hiển thị
    getDataAndDisplayTable(vFilterData);
  }

  // function xử lý sự kiện click button Dice History
  function onBtnDiceHistoryClick() {
    $("#modal-dice-history").modal("show");
    // B1: Thu thập dữ liệu
    getUserData(this);
    // B2: Kiểm tra dữ liệu
    // B3: Gọi API lấy lịch sử tung xúc xắc
    let vAjaxRequest = apiGetDiceHistory();
    vAjaxRequest.done(function(data) {
      // B4: Xử lý hiển thị
      displayUserDetailOnDiceHistoryModal();
      displayDiceHistoryTable(data);
    })
  }
  
  /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
  // function thu thập dữ liệu cho button Dice History và Voucher History
  // function trả về dữ liệu cho đối tượng gUser 
  function getUserData(paramButton) {
    let vRowClick = $(paramButton).closest("tr");
    let vUserData = gTable.row(vRowClick).data();
    gUser.username = vUserData.username;
    gUser.firstname = vUserData.firstname;
    gUser.lastname = vUserData.lastname;
  }

  // function hiển thị user detal lên modal Dice History
  function displayUserDetailOnDiceHistoryModal() {
    $("#inp-dice-username").val(gUser.username);
    $("#inp-dice-firstname").val(gUser.firstname);
    $("#inp-dice-lastname").val(gUser.lastname);
  }

  // function gọi API lấy lịch sử tung xúc xắc
  function apiGetDiceHistory() {
    return $.ajax({
      url: gBASE_URL + "/dice-history?username=" + gUser.username,
      type: "GET",
    })
  }

  // function hiển thị table Dice History
  function displayDiceHistoryTable(paramDiceHistory) {
    var vStt = 1
    const vTABLE_ROW = ["stt", "dices"];
    const vSTT_COL = 0;
    const vDICE_COL = 1;
    let vDiceHistory = paramDiceHistory.dices;
    $("#table-dice-history tbody").html("");
    for (let bIndex = 0; bIndex < vDiceHistory.length; bIndex++) {
      let vNewRow = $("<tr>").appendTo($("#table-dice-history tbody"));
      vNewRow.append(
        $("<td>").html(bIndex + 1),
        $("<td>").html(vDiceHistory[bIndex])  
      );
    }
  }

  // function xử lý hiển thị User data table
  function getDataAndDisplayTable(paramUserData) {
    gSTT = 1;
    gTable.clear();
    gTable.rows.add(paramUserData);
    gTable.draw();
  }

  // function tìm và hiển thị Role Name theo Role ID
  function getRoleNameByRoleId(paramRoleId) {
    let vRoleName = "";
    let vIndex = 0;
    let vFound = false;
    while (!vFound && vIndex < gRoleObjects.length) {
      if (gRoleObjects[vIndex].roleId == paramRoleId) {
        vRoleName = gRoleObjects[vIndex].roleName;
        vFound = true;
      }
      vIndex++;
    }
    return vRoleName;
  }

  // function gán Role data vào thẻ select
  function loadRoleDataToSelect() {
    for (let bRole of gRoleObjects) {
      $("#select-role").append(
        $("<option>").val(bRole.roleId).text(bRole.roleName)
      );
    }
  }

  // function xử lý hiển thị Filter Data
  function getFilterRoleData(paramRoleId) {
    let vFilterData = [];
    for (let bUser of gUserObjects) {
      if (bUser.roleId == paramRoleId) {
        vFilterData.push(bUser);
      }
    }
    return vFilterData;
  }
  
</script>

</html>